#!/bin/sh

clear_if_two() {
    fw_printenv > /ram/temp_env.txt
    tmp=`awk '{if(index($0,"'"$1"'=") == 1) {print $0;}  }' /ram/temp_env.txt | wc -l`
    if [ "$tmp" != "1" ]; then
	fw_setenv $1
	echo "Clear second definition for bootcmd"
    fi
    rm -f /ram/temp_env.txt
}

case $1 in
    dhcp)
	clear_if_two bootcmd 	
	fw_setenv bootcmd "run net"
	;;
    flash)
	clear_if_two bootcmd 	
	fw_setenv bootcmd "run flash_self"
	;;
    flash2)
	clear_if_two bootcmd 	
	fw_setenv bootcmd "run flash_self2"
	;;
    up_ip_tftp)
	clear_if_two bootcmd
	fw_setenv bootcmd "setenv addup_url 'setenv bootargs \${bootargs} urlman=on';tftpboot 84000000 \${tftp_path_conf};run nfsargs addmisc addup_url; bootm; reset"
	;;
    up_dhcp_tftp)
	clear_if_two bootcmd
	fw_setenv bootcmd "setenv autoload no; dhcp; setenv serverip \${serverip_conf}; tftpboot 84000000 \${tftp_path_conf}; setenv addup_url  'setenv bootargs \${bootargs} urldhcp=on'; run nfsargs addmisc addup_url; bootm; reset"
	;;
    up_mc)
	clear_if_two bootcmd
	fw_setenv bootcmd "setenv ipaddr 192.168.243.249; setenv addmc 'setenv bootargs \${bootargs} mcman=on'; setenv mcip \${mcip_conf}; setenv mcport \${mcport_conf}; mcload; run nfsargs addmisc addmc; bootm; reset"
	;;
    up_mc_url)
	clear_if_two bootcmd
	
	STAT_IP=`fw_printenv ipaddr_conf 2>/dev/null`
	STAT_IP=${STAT_IP#ipaddr_conf=}
	if [ "$STAT_IP" ]; then
	    IPB=`fw_printenv ipaddr 2>/dev/null`
	    IPB=${IPB#ipaddr=}
	    if [ "$IPB" != "$STAT_IP" ]; then 
		fw_setenv ipaddr $STAT_IP
	    fi
	    fw_setenv bootcmd "setenv addmc 'setenv bootargs \${bootargs} urlman=on'; setenv mcip \${mcip_conf}; setenv mcport \${mcport_conf}; mcload; run nfsargs addmisc addmc; bootm; reset"
	else
	    curIP=`/home/default/rdir.cgi IPAddress`
	    if [ "$curIP" == "" ] ; then
		fw_setenv bootcmd "setenv ipaddr 192.168.243.249;setenv addmc 'setenv bootargs \${bootargs} urlman=on'; setenv mcip \${mcip_conf}; setenv mcport \${mcport_conf}; mcload; run nfsargs addmisc addmc; bootm; reset"
	    else
		fw_setenv bootcmd "setenv ipaddr $curIP;setenv addmc 'setenv bootargs \${bootargs} urlman=on'; setenv mcip \${mcip_conf}; setenv mcport \${mcport_conf}; mcload; run nfsargs addmisc addmc; bootm; reset"
	    fi
	fi
	;;
    up_local)
	exit 1
        tmp_mtd=`awk '/mtd[4-9]/ {if(index($4,"Bootstrap")==2) {if(substr($1,4,1) > 4) {print(substr($1,4,1)-4); exit;} }  }' /proc/mtd`
	if [ "$tmp_mtd" == "" ]; then 
	  exit 1
	fi
	tmp2=`fw_printenv Bootstrap_Version 2>/dev/null`
        tmp2=${tmp2#Bootstrap_Version=}
	if [ "$tmp2" == "" ]; then 
	  exit 1
	fi
	clear_if_two bootcmd
	fw_setenv bootcmd "setenv partition nand0,$tmp_mtd; setenv addbs 'setenv bootargs \${bootargs} urlman=on'; fsload 0x84000000 Bootstrap; run flashargs addbs addmisc; bootm; reset"
	;;
    up_usb)
	exit 1
	#this mode is not allowed
	clear_if_two bootcmd
	if [ -f /ram/mag250 ]; then
	    fw_setenv bootcmd "setenv addusbbs 'setenv bootargs \${bootargs} usbman=on'; usb start; fatload usb 0:1 80000000 mag250/Bootstrap; usb stop; run flashargs addusbbs addmisc; bootm; reset"
	elif [ -f /ram/mag255 ]; then
	    fw_setenv bootcmd "setenv addusbbs 'setenv bootargs \${bootargs} usbman=on'; usb start; fatload usb 0:1 80000000 mag255/Bootstrap; usb stop; run flashargs addusbbs addmisc; bootm; reset"
	elif [ -f /ram/mag270 ]; then
	    fw_setenv bootcmd "setenv addusbbs 'setenv bootargs \${bootargs} usbman=on'; usb start; fatload usb 0:1 80000000 mag270/Bootstrap; usb stop; run flashargs addusbbs addmisc; bootm; reset"
	else
	    fw_setenv bootcmd "setenv addusbbs 'setenv bootargs \${bootargs} usbman=on'; usb start; fatload usb 0:1 84000000 mag200/Bootstrap; usb stop; run flashargs addusbbs addmisc; bootm; reset"
	fi 
	;;
    *)
	;;
esac	
reboot	
