#!/bin/sh
# /usr/bin/update_img.sh $upd_ver $upd_url $upd_mode
echo -n "/usr/bin/update_img.s $@"

# Section 1: Check file imageupdate present and his version is correct
tmpfile=/ram/short_img
max=1000

if [ "$2" == "" ]; then
  exit 1;
fi

if [ "$3" == "" ]; then
  exit 1;
fi

up_url=$2
rm -f $tmpfile 2>/dev/null 1>/dev/null

URL_HTTP=`echo $up_url |awk '{ if($1~/^http:\/\//) {print $1; exit; } }'`
TFTP_IP=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,1,i-1); exit; } }'`
TFTP_ROOTPATH=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,i+1); exit; } }'`
mcip_img=`echo $up_url |awk '{ if($1~/^igmp:\/\//) { tmp = substr($1,8); i=index(tmp,":"); print substr(tmp,1,i-1); exit; } }'`

if [ "$mcip_img" == "" ]; then
    if [ "$URL_HTTP" == "" ]; then
      if [ "$TFTP_IP" == "" ] || [ "$TFTP_ROOTPATH" == "" ]; then
        exit 1;
      else
        /bin/tftp -l /proc/self/fd/1 -g -r $TFTP_ROOTPATH $TFTP_IP 2>/dev/null | dd of=$tmpfile bs=1 count=$max 2>/dev/null 1>/dev/null
      fi
    else
      /bin/wget $URL_HTTP  -O /dev/stdout 2>/dev/null | dd of=$tmpfile bs=1 count=$max 2>/dev/null 1>/dev/null
    fi
    
    if [ ! -e $tmpfile ]; then
      echo -n "Update_Img:File absent"	
      exit 1    
    fi

    img_version=`awk '{if(index($0,"Image Version:") == 1) {print substr($0,length("Image Version:")+1,length($0)); exit; }  }' $tmpfile`

    rm $tmpfile

    if [ -z "$img_version" ]; then
        exit 1
    fi
    let img_version+=0
    if [ "$?" -ne "0" ]; then
        echo -n "Update_Img: Image Version not number"	
        exit 1
    fi
    if [ "$1" !=  "$img_version" ]; then
        echo -n "Update_Img: Image Version($img_version) not equal to request version($1)"	
        exit 1
    fi
fi
  
# Section 2: Setup parametrs and check path for BootStrap and restart

if [ "$3" == "local"]; then
    /usr/bin/rebootmng.sh up_local
    exit 1
fi 

TFTP_IP=`echo $3 |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,1,i-1); exit; } }'`
TFTP_ROOTPATH=`echo $3 |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,i+1); exit; } }'`
mcip=`echo $3 |awk '{ if($1~/^igmp:\/\//) { tmp = substr($1,8); i=index(tmp,":"); print substr(tmp,1,i-1); exit; } }'`
mcport=`echo $3 |awk '{ if($1~/^igmp:\/\//) { tmp = substr($1,8); i=index(tmp,":"); print substr(tmp,i+1); exit; } }'`

if [ "$TFTP_IP" == "" ] || [ "$TFTP_ROOTPATH" == "" ]; then
    if [ "$mcip" == "" ]; then
        echo -n "Update_Img: update_mode incorrect: $3"	
        exit 1
    else
	if [ -z "$mcport" ]; then
	    mcport=9000
	fi
        echo "Setup parameter for MC_Update:$mcip:$mcport and restart"
	append=' mcip_conf '$mcip
	append2=' | mcport_conf '$mcport
	append3=' | update_url '$2
	fw_setenv $append $append2 $append3
        /usr/bin/rebootmng.sh up_mc_url
    fi
else
    echo "Setup parameter for TFTP and restart"
    append=' serverip_conf '$TFTP_IP
    append2=' |  tftp_path_conf '$TFTP_ROOTPATH
    append3=' | update_url '$2
    fw_setenv $append $append2 $append3
    /usr/bin/rebootmng.sh up_dhcp_tftp
fi
