#!/bin/sh

. /etc/utils/shell-utils.sh

DEBUG=0

export USER=root
export HOME=/root

cd /root/modules
. ./load_env.sh

hasfp=0
if [ -f /ram/mag200 ] ; then
    ver=`/home/default/rdir.cgi HardwareVersion`
    case "$ver" in
        0.3|0.3-*|0.4|0.4-*)
        ;;
        *)
            hasfp=1
            echo 1 > /ram/hasfp
        ;;
    esac
fi

/etc/lirc/lircinit.sh

echo 1000000 > /proc/sys/net/core/rmem_max

if [ "$hasfp" == "1" ] ; then
    . /tty1
    /home/default/setFpanel.sh caption .200
    fpqevent -t 750 &
fi

log "Before loop (/ram/dhcp_ready)"

PORTAL1=`fw_printenv portal1 2>/dev/null`
PORTAL1=${PORTAL1#portal1=}
PORTAL2=`fw_printenv portal2 2>/dev/null`
PORTAL2=${PORTAL1#portal2=}
USE_PORTAL_DHCP=`fw_printenv use_portal_dhcp 2>/dev/null`
USE_PORTAL_DHCP=${USE_PORTAL_DHCP#use_portal_dhcp=}

BYPASS_WAIT=1

if [ ! -f /ram/dhcp_ready ]; then
    if [ "$PORTAL1" == "" ] && [ "$PORTAL2" == "" ] && [ "$USE_PORTAL_DHCP" != "true" ] ; then
	log "all portals disabled."
        BYPASS_WAIT=1
    else
        log "some portals is active..."
        read_nvram_var "ipaddr_conf" "STAT_IP"
        read_nvram_var "wifi_int_ip" "wifi_int_ip"
        read_nvram_var "lan_noip" "LAN_NO_IP"

        if [ "$LAN_NO_IP" == "true" ]; then
	    if [ "$wifi_int_ip" == "" ] || [ "$wifi_int_ip" == "0.0.0.0" ] ; then
	        log "dhcp config found (only WiFi). waiting..."
		BYPASS_WAIT=0
	    fi
        else
	    if [ "$STAT_IP" == "" ] || [ "$wifi_int_ip" == "" ] || [ "$wifi_int_ip" == "0.0.0.0" ] ; then
	        log "dhcp config found (LAN or WiFi). waiting..."
	        BYPASS_WAIT=0
	    fi
	fi
    fi
fi

if [ "$BYPASS_WAIT" == "0" ] ; then
    i=60;
    while [ "$i" -ne "0" ] ; do
	if [ -f /ram/dhcp_ready ] ; then
	    log "/ram/dhcp_ready FOUND"
	    break;
	fi
	log "not found, sleeping..."
	sleep 1;
	i=$(($i-1));
    done;
fi

log "starting portal"
/test.sh > /dev/zero

